#include "GraphicsClass.h"


GraphicsClass::GraphicsClass(void)
	{
	m_D3D = 0;
	m_Camera = 0;
	m_Model = 0;
	 m_AxisModel = 0;
	m_ColorShader = 0;

	 m_PlaneModel = 0;
	 m_CubeModel = 0;
	 m_LightShader = 0;
	 m_LightTexShader = 0;
	}

GraphicsClass::GraphicsClass(const GraphicsClass&)
	{

	}
GraphicsClass::~GraphicsClass(void)
	{
	}

bool GraphicsClass:: Initialize(int screenWidth, int screenHeight, HWND hwnd)
	{
	bool result;

	//Ѿڣͷŵ
	Shutdown();

	// һD3DClass.
	m_D3D = new D3DClass;
	if(!m_D3D)
		{
		return false;
		}

	// D3DClassʼ
	result = m_D3D->Initialize(screenWidth, screenHeight, VSYNC_ENABLED, hwnd, FULL_SCREEN, SCREEN_DEPTH, SCREEN_NEAR);
	if(!result)
		{
		MessageBox(hwnd, L"Could not initialize Direct3D", L"Error", MB_OK);
		return false;
		}

	//
	m_Camera = new CameraClass;
	if(!m_Camera)
		{
		return false;
		}

	// λ.
	D3DXVECTOR3 campos = D3DXVECTOR3(8.0f, 3.0f, -20.0f);
	m_Camera->setPosition(&campos);

	// ģͶ.
	m_Model = new ModelClass;
	if(!m_Model)
		{
		return false;
		}

	// ʼģͶ.
	result = m_Model->Initialize(m_D3D->GetDevice());
	if(!result)
		{
		MessageBox(hwnd, L"Could not initialize the model object.", L"Error", MB_OK);
		return false;
		}

	// ὨģͶ.
	m_AxisModel = new AxisModelClass;
	if(!m_AxisModel)
		{
		return false;
		}
	// ʼģͶ.
	result = m_AxisModel->Initialize(m_D3D->GetDevice());
	if(!result)
		{
		MessageBox(hwnd, L"Could not initialize the axis model object.", L"Error", MB_OK);
		return false;
		}

	// ƽģͶ.
	m_PlaneModel = new PlaneModelClass;
	if(!m_PlaneModel)
		{
		return false;
		}
	// ʼƽģͶ.
	result = m_PlaneModel->Initialize(m_D3D->GetDevice(),100,100,4.0,L"grass.dds");
	if(!result)
		{
		MessageBox(hwnd, L"Could not initialize the plane model object.", L"Error", MB_OK);
		return false;
		}

	// cubeģͶ
	m_CubeModel = new CubeModelClass;
	if(!m_CubeModel)
		{
		return false;
		}
	// ʼcubeģͶ.
	result = m_CubeModel->Initialize(m_D3D->GetDevice(), "cube.txt",L"tong.dds");
	if(!result)
		{
		MessageBox(hwnd, L"Could not initialize the axis model object.", L"Error", MB_OK);
		return false;
		}

	// shader
	m_ColorShader = new ColorShaderClass;
	if(!m_ColorShader)
		{
		return false;
		}

	// ʼshader
	result = m_ColorShader->Initialize(m_D3D->GetDevice(), hwnd);
	if(!result)
		{
		MessageBox(hwnd, L"Could not initialize the color shader object.", L"Error", MB_OK);
		return false;
		}

	// shader
	m_LightShader = new LightShaderClass;
	if(!m_LightShader)
		{
		return false;
		}

	//ʼshader
	result = m_LightShader->Initialize(m_D3D->GetDevice(), hwnd);
	if(!result)
		{
		MessageBox(hwnd, L"Could not initialize the light shader object.", L"Error", MB_OK);
		return false;
		}

	// shader
	m_LightTexShader = new LightTexShaderClass;
	if(!m_LightTexShader)
		{
		return false;
		}

	//ʼshader
	result = m_LightTexShader->Initialize(m_D3D->GetDevice(), hwnd);
	if(!result)
		{
		MessageBox(hwnd, L"Could not initialize the light texture shader object.", L"Error", MB_OK);
		return false;
		}
	return true;
	}

void GraphicsClass::Shutdown()
	{

	// ͷŹshader.
	if(m_LightTexShader)
		{
		m_LightTexShader->Shutdown();
		delete m_LightTexShader;
		m_LightTexShader = 0;
		}

	// ͷŹղshader.
	if(m_LightShader)
		{
		m_LightShader->Shutdown();
		delete m_LightShader;
		m_LightShader = 0;
		}

	// ͷshader.
	if(m_ColorShader)
		{
		m_ColorShader->Shutdown();
		delete m_ColorShader;
		m_ColorShader = 0;
		}

	// ͷģͶ.
	if(m_Model)
		{
		m_Model->Shutdown();
		delete m_Model;
		m_Model = 0;
		}
	// ͷģͶ.
	if(m_AxisModel)
		{
		m_AxisModel->Shutdown();
		delete m_AxisModel;
		m_AxisModel = 0;
		}

	//ͷplaneģͶ
	if(m_PlaneModel)
		{
		m_PlaneModel->Shutdown();
		delete m_PlaneModel;
		m_PlaneModel = 0;
		}

	//ͷcubeģͶ
	if(m_CubeModel)
		{
		m_CubeModel->Shutdown();
		delete m_CubeModel;
		m_CubeModel = 0;
		}

	// ͷ
	if(m_Camera)
		{
		delete m_Camera;
		m_Camera = 0;
		}

	//m_D3D
	if(m_D3D)
		{
		m_D3D->Shutdown();
		delete m_D3D;
		m_D3D = 0;
		}

	return;
	}


bool GraphicsClass::Frame(float dt)
	{
	bool result;


	// RenderȾ3D
	// RenderGraphicsClass˽к.
	result = Render(dt);
	if(!result)
		{
		return false;
		}

	return true;
	}


bool GraphicsClass::Render(float dt)
	{

	D3DXMATRIX viewMatrix, projectionMatrix, worldMatrix,worldMatrix1;
	bool result;

  //ʼworldΪλ.
	//þʵ־ֲ굽ת
	D3DXMatrixIdentity(&worldMatrix);
   D3DXMatrixIdentity(&worldMatrix1);
	// framebuffer.Ϊǳɫ
	m_D3D->BeginScene(0.0f, 0.0f, 0.5f, 1.0f);

	// õ3.
	m_Camera->getViewMatrix(&viewMatrix);
		
	m_D3D->GetProjectionMatrix(projectionMatrix);

	m_AxisModel->Render(m_D3D->GetDeviceContext());
	// shaderȾ.
	result = m_ColorShader->Render(m_D3D->GetDeviceContext(), m_AxisModel->GetIndexCount(), worldMatrix, viewMatrix, projectionMatrix);
	if(!result)
		{
		return false;
		}	
	// ģͶߣ׼Ⱦ.
	m_Model->Render(m_D3D->GetDeviceContext());
	
  //ִƽƲõյģ
	D3DXMatrixTranslation(&worldMatrix1, 4.0, 0.0, 0.0);

	// shaderȾ.
	result = m_ColorShader->Render(m_D3D->GetDeviceContext(), m_Model->GetIndexCount(), worldMatrix1, viewMatrix, projectionMatrix);
	if(!result)
		{
		return false;
		}
  //ִƽƲõյģ
	D3DXMatrixTranslation(&worldMatrix1, 8.0, 0.0, 0.0);
	// shaderȾ.
	result = m_ColorShader->Render(m_D3D->GetDeviceContext(), m_Model->GetIndexCount(), worldMatrix1, viewMatrix, projectionMatrix);
	if(!result)
		{
		return false;
		}
 
	//õλúһЩʹϵ
	D3DXVECTOR3 camerapos;

	m_Camera->getPosition(&camerapos);

	 LightBufferType light;
	 MaterialBufferType material;
	 CameraBufferType camera;
	 LightClass mLight[NUM_LIGHTS];
	 static float angle = 0;
	 angle += dt;
	 if(angle > 6.183)
		 angle = 0;

	 float x, z;
	 x = 6*cos(angle);
	 z = 6*sin(angle);
	 camera.cameraPosition = D3DXVECTOR4(camerapos.x,camerapos.y,camerapos.z, 1.0);
	 material.Ka = D3DXVECTOR4(0.0, 0.0, 0.0, 1.0);
	 material.Ke = D3DXVECTOR4(0.0, 0.0, 0.0, 1.0);

	 mLight[0].SetLightPosition(x, 5.0,z,1.0);
	 mLight[1].SetLightPosition(-3.0, 4.0, -5.0,1.0);
	 mLight[1].SetLightSpotLight(0.3, 0.2, 0.0, 0.0);
	 mLight[1].SetLightColor(0.5, 0.3, 0.2, 1.0);

	 light.lightPosition[0] = mLight[0].GetPosition();
	 light.lightColor[0] = mLight[0].GetLightColor();
	 light.globalAmbient[0] = mLight[0].GetGlobalAmbient();
	 light.attenuation[0] = mLight[0].GetLightAttenuation();
	 light.lightDirection[0] = mLight[0].GetDirection();
	 light.shininess[0] = mLight[0].GetShininess();
	 light.spotlight[0] = mLight[0].GetSpotLight();

	 light.lightPosition[1] = mLight[1].GetPosition();
	 light.lightColor[1] = mLight[1].GetLightColor();
	 light.globalAmbient[1] = mLight[1].GetGlobalAmbient();
	 light.attenuation[1] = mLight[1].GetLightAttenuation();
	 light.lightDirection[1] = mLight[1].GetDirection();
	 light.shininess[1] = mLight[1].GetShininess();
	 light.spotlight[1] = mLight[1].GetSpotLight();

	//cubeݷ뻺׼Ⱦ
	m_CubeModel->Render(m_D3D->GetDeviceContext());
	//light shaderȾ
	result = m_LightTexShader->Render(m_D3D->GetDeviceContext(), m_CubeModel->GetIndexCount(), worldMatrix, viewMatrix, projectionMatrix, 
		 		light, material, camera,m_CubeModel->GetTexture());
	if(!result)
		{
		return false;
		}

	//planeݷ뻺׼Ⱦ
	m_PlaneModel->Render(m_D3D->GetDeviceContext());
	//light shaderȾ
//	result = m_LightShader->Render(m_D3D->GetDeviceContext(), m_PlaneModel->GetIndexCount(), worldMatrix1, viewMatrix, projectionMatrix, 
//			light, material, camera);
	result = m_LightTexShader->Render(m_D3D->GetDeviceContext(), m_PlaneModel->GetIndexCount(), worldMatrix, viewMatrix, projectionMatrix, 
		light, material, camera,m_PlaneModel->GetTexture());
	if(!result)
		{
		return false;
		}

	//framebufferеͼpresentĻ.
	m_D3D->EndScene();

	return true;
	}