#include "PlaneModelClass.h"


PlaneModelClass::PlaneModelClass(void)
	{
	m_vertexBuffer = 0;
	m_indexBuffer = 0;

	m_Texture = 0;
	}

PlaneModelClass::PlaneModelClass(const PlaneModelClass& others)
	{

	}

PlaneModelClass::~PlaneModelClass(void)
	{
	}

bool PlaneModelClass::Initialize(ID3D11Device* device,int m, int n, float dx,WCHAR* textureFilename)
	{
	bool result;


	// ʼ㻺Ͷ.
	result = InitializeBuffers(device,m, n, dx,textureFilename);
	if(!result)
		{
		return false;
		}
	// װ.
	result = LoadTexture(device, textureFilename);
	if(!result)
		{
		return false;
		}
	return true;
	}

void PlaneModelClass::Shutdown()
	{

	// ͷ
	ReleaseTexture();
	// ͷŶ.
	ShutdownBuffers();

	return;
	}

void PlaneModelClass::Render(ID3D11DeviceContext* deviceContext)
	{
	// Ѷͼιߣ׼Ⱦ.
	RenderBuffers(deviceContext);

	return;
	}

int PlaneModelClass::GetIndexCount()
	{
	//
	return m_indexCount;
	}

bool PlaneModelClass::InitializeBuffers(ID3D11Device* device,int m, int n, float dx,WCHAR* textureFilename)
	{
	VertexType* vertices;
	unsigned long* indices;
	D3D11_BUFFER_DESC vertexBufferDesc, indexBufferDesc;
	D3D11_SUBRESOURCE_DATA vertexData, indexData;
	HRESULT result;

	//õĿ
	//ȵõεĿȻ3ǶĿ
	m_vertexCount = m*n;
	m_indexCount    = (m-1)*(n-1)*2*3;

	// ʱ.
	vertices = new VertexType[m_vertexCount];
	if(!vertices)
		{
		return false;
		}

	float halfWidth = (n-1)*dx*0.5f;
	float halfDepth = (m-1)*dx*0.5f;

	for(int i = 0; i < m; ++i)
		{
		float z = halfDepth - i*dx;
		for(int j = 0; j < n; ++j)
			{
			float x = -halfWidth + j*dx;

			float y = -3.0;

			vertices[i*n+j].position = D3DXVECTOR3(x, y, z);
			vertices[i*n+j].normal = D3DXVECTOR3(0.0,1.0f,0.0);
			vertices[i*n+j].Kd  = D3DXVECTOR4(0.0, 1.0, 0.0,1.0);;
			vertices[i*n+j].Ks =  D3DXVECTOR4(0.2, 0.2, 0.2,1.0);

			if(i%2==0&&j%2==0)
				vertices[i*n+j].texture =  D3DXVECTOR2(0.0, 0.0);
			if(i%2==1&&j%2==0)
				vertices[i*n+j].texture =  D3DXVECTOR2(1.0, 0.0);
			if(i%2==0&&j%2==1)
				vertices[i*n+j].texture =  D3DXVECTOR2(0.0, 1.0);
			if(i%2==1&&j%2==1)
				vertices[i*n+j].texture =  D3DXVECTOR2(1.0, 1.0);
			}
		}

	// .
	indices = new unsigned long[m_indexCount];
	if(!indices)
		{
		return false;
		}

	// ÿgridó.
	int k = 0;
	for(int i = 0; i < m-1; ++i)
		{
		for(int j = 0; j < n-1; ++j)
			{
			indices[k]   = i*n+j;
			indices[k+1] = i*n+j+1;
			indices[k+2] = (i+1)*n+j;

			indices[k+3] = (i+1)*n+j;
			indices[k+4] = i*n+j+1;
			indices[k+5] = (i+1)*n+j+1;

			k += 6; //һgrid
			}
		}

	// ö㻺
	vertexBufferDesc.Usage = D3D11_USAGE_DEFAULT;
	vertexBufferDesc.ByteWidth = sizeof(VertexType) * m_vertexCount;
	vertexBufferDesc.BindFlags = D3D11_BIND_VERTEX_BUFFER;
	vertexBufferDesc.CPUAccessFlags = 0;
	vertexBufferDesc.MiscFlags = 0;
	vertexBufferDesc.StructureByteStride = 0;

	// ָ򱣴涥ݵʱ.
	vertexData.pSysMem = vertices;
	vertexData.SysMemPitch = 0;
	vertexData.SysMemSlicePitch = 0;

	// 㻺.
	result = device->CreateBuffer(&vertexBufferDesc, &vertexData, &m_vertexBuffer);
	if(FAILED(result))
		{
		HR(result);
		return false;
		}

	// .
	indexBufferDesc.Usage = D3D11_USAGE_DEFAULT;
	indexBufferDesc.ByteWidth = sizeof(unsigned long) * m_indexCount;
	indexBufferDesc.BindFlags = D3D11_BIND_INDEX_BUFFER;
	indexBufferDesc.CPUAccessFlags = 0;
	indexBufferDesc.MiscFlags = 0;
	indexBufferDesc.StructureByteStride = 0;

	// ָʱ.
	indexData.pSysMem = indices;
	indexData.SysMemPitch = 0;
	indexData.SysMemSlicePitch = 0;

	// .
	result = device->CreateBuffer(&indexBufferDesc, &indexData, &m_indexBuffer);
	if(FAILED(result))
		{
		HR(result);
		return false;
		}

	// ͷʱ.
	delete [] vertices;
	vertices = 0;

	delete [] indices;
	indices = 0;

	return true;
	}

void PlaneModelClass::ShutdownBuffers()
	{
	// ͷŶ㻺.
	if(m_indexBuffer)
		{
		m_indexBuffer->Release();
		m_indexBuffer = 0;
		}

	// ͷ
	if(m_vertexBuffer)
		{
		m_vertexBuffer->Release();
		m_vertexBuffer = 0;
		}

	return;
	}

void PlaneModelClass::RenderBuffers(ID3D11DeviceContext* deviceContext)
	{
	unsigned int stride;
	unsigned int offset;


	// ö㻺Ⱥƫ.
	stride = sizeof(VertexType); 
	offset = 0;

	//input assemberl׶ΰ󶨶㻺壬ԱܹȾ
	deviceContext->IASetVertexBuffers(0, 1, &m_vertexBuffer, &stride, &offset);

	//input assemberl׶ΰ壬ԱܹȾ
	deviceContext->IASetIndexBuffer(m_indexBuffer, DXGI_FORMAT_R32_UINT, 0);

	// Ԫ壬Ⱦб.
	deviceContext->IASetPrimitiveTopology(D3D11_PRIMITIVE_TOPOLOGY_TRIANGLELIST);

	return;
	}

ID3D11ShaderResourceView* PlaneModelClass::GetTexture()
	{
	return m_Texture->GetTexture();
	}

bool PlaneModelClass::LoadTexture(ID3D11Device* device, WCHAR* filename)
	{
	bool result;


	// 
	m_Texture = new TextureClass;
	if(!m_Texture)
		{
		return false;
		}

	//ʼ.
	result = m_Texture->Initialize(device, filename);
	if(!result)
		{
		return false;
		}

	return true;
	}
void PlaneModelClass::ReleaseTexture()
	{
	// ͷ.
	if(m_Texture)
		{
		m_Texture->Shutdown();
		delete m_Texture;
		m_Texture = 0;
		}

	return;
	}
