#pragma once

#include <d3d11.h>
#include <d3dx10math.h>
#include "common.h"
#include <fstream>
using namespace std;

class CubeModelClass
	{
	private:
		struct VertexType
			{
			D3DXVECTOR3 position;
			D3DXVECTOR3 normal; //
			D3DXVECTOR3 tangent; //
			D3DXVECTOR3 binormal; //
			D3DXVECTOR2 texture;//
			D3DXVECTOR4 Kd;  //ϵ
			D3DXVECTOR4 Ks;  //ʵĸ߹ϵ
			};
		struct ModelType
			{
			float x, y, z;
			float tu, tv;
			float nx, ny, nz;
			float tx, ty, tz;
			float bx, by, bz;
			};

		struct TempVertexType
			{
			float x, y, z;
			float tu, tv;
			float nx, ny, nz;
			};

		struct VectorType
			{
			float x, y, z;
			};
	public:
		CubeModelClass(void);
		CubeModelClass(const CubeModelClass &);
		~CubeModelClass(void);
		bool Initialize(ID3D11Device*, char*);
		void Shutdown();
		void Render(ID3D11DeviceContext*);

		int GetIndexCount();
	private:
		bool InitializeBuffers(ID3D11Device*);
		void ShutdownBuffers();
		void RenderBuffers(ID3D11DeviceContext*);
		bool LoadModel(char*);
		void ReleaseModel();
		void CalculateModelVectors();
		void CalculateTangentBinormal(TempVertexType, TempVertexType, TempVertexType, VectorType&, VectorType&);
		void CalculateNormal(VectorType, VectorType, VectorType&);
		//㻺Ͷ
		ID3D11Buffer *m_vertexBuffer, *m_indexBuffer;
		int m_vertexCount, m_indexCount;

		ModelType* m_model;

	};

