////////////////////////////////////////////////////////////////////////////////
// Filename: light.vs
////////////////////////////////////////////////////////////////////////////////

/////////////
// GLOBALS //
/////////////
cbuffer MatrixBuffer
{
    matrix worldMatrix;
    matrix viewMatrix;
    matrix projectionMatrix;
};

//////////////
// TYPEDEFS //
//////////////
struct VertexInputType
{
    float4 position : POSITION;
    float3 normal : NORMAL;
    float3 tangent : TANGENT;
    float3 binormal : BINORMAL;

    float2 tex : TEXCOORD0; //
	float4 Kd : DIFFUSE;
	float4 Ks: SPECULAR;
};

struct PixelInputType
{
    float4 position : SV_POSITION;
	float4 worldposition: POSITION;
	float3 worldnormal: NORMAL;
    float3 worldtangent : TANGENT;
    float3 worldbinormal : BINORMAL;

	float2 tex : TEXCOORD0;
	float4 Kd : DIFFUSE;
	float4 Ks: SPECULAR;
};

////////////////////////////////////////////////////////////////////////////////
// Vertex Shader
////////////////////////////////////////////////////////////////////////////////
PixelInputType LightVertexShader(VertexInputType input)
{
    PixelInputType output;
    float4 worldPosition;


    // ı䶥Ϊĸ.
    input.position.w = 1.0f;

    // Calculate the position of the vertex against the world, view, and projection matrices.
    output.position = mul(input.position, worldMatrix);
    output.position = mul(output.position, viewMatrix);
    output.position = mul(output.position, projectionMatrix);
    
    
    // ϵеĶ㷨.
    output.worldnormal = mul(input.normal, (float3x3)worldMatrix);
	output.worldtangent = mul(input.tangent, (float3x3)worldMatrix);
	output.worldbinormal = mul(input.binormal, (float3x3)worldMatrix);

	
	//ϵλ
    worldPosition = mul(input.position, worldMatrix);
	output.worldposition =  worldPosition;
	
	//
	output.tex = input.tex;

	//͸߹ϵ
	output.Kd = input.Kd;
	output.Ks = input.Ks;

    return output;
}

