#pragma once

#include <windows.h>
#include "d3dclass.h"
#include "cameraclass.h"
#include "modelclass.h"
#include "AxisModelClass.h"
#include "colorshaderclass.h"
#include "CubeModelClass.h"
#include "PlaneModelClass.h"
#include "LightShaderClass.h"
#include "WaterModelClass.h"
#include "common.h"
#include "LightTexShaderClass.h"
#include "TexManagerClass.h"
/////////////
// GLOBALS //
/////////////
const bool FULL_SCREEN = false;//Ƿȫ
const bool VSYNC_ENABLED = true;//Ƿֱͬ
const float SCREEN_DEPTH = 1000.0f;//ȣԶ
const float SCREEN_NEAR = 0.1f;//ȣ

class GraphicsClass
	{
	public:
		GraphicsClass(void);
		GraphicsClass(const GraphicsClass&);
		~GraphicsClass(void);
		bool Initialize(int, int, HWND);
		void Shutdown();
		bool Frame(float);
		CameraClass* m_Camera;//ΪpublicSystemClassп
	private:
		bool Render(float);

		//һD3DClassԱ
		D3DClass* m_D3D;
		
		ModelClass* m_Model;
		AxisModelClass* m_AxisModel;
		ColorShaderClass* m_ColorShader;

		
		PlaneModelClass* m_PlaneModel;
		CubeModelClass* m_CubeModel;
		WaterModelClass* m_WaterModel;

		LightShaderClass* m_LightShader;
		LightTexShaderClass* m_LightTexShader;
		TexManagerClass*  m_TexManager;
		ID3D11ShaderResourceView* m_textures;

	};

